<?php
namespace Teknisa\CADFIS\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Request\Row as Row;
use Teknisa\Libs\Service\CRUD as CrudService;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Teknisa\CADFIS\Services\Ger16900CodigoFiscalOperacoesPrestacoesService;

class Ger16900CodigoFiscalOperacoesPrestacoesController{
  
  protected $crudService;
  protected $parameterBag;
  protected $environment;
  protected $ger16900codigofiscaloperacoesprestacoesservice;
  
  public function __construct(CrudService $crudService, ParameterBag $parameterBag, Environment $environment, Ger16900CodigoFiscalOperacoesPrestacoesService $ger16900codigofiscaloperacoesprestacoesservice){
      $this->crudService  = $crudService;
      $this->parameterBag = $parameterBag;
      $this->environment  = $environment;
      $this->ger16900codigofiscaloperacoesprestacoesservice = $ger16900codigofiscaloperacoesprestacoesservice;
  }
  
  
  public function salvarValidadeCfop(Row $row, Response $response) {
     try{

       $row  = $row->getRow();

       $retorno = $this->ger16900codigofiscaloperacoesprestacoesservice->salvaValidadeCfop($row);
       
       $response->addDataSet(new DataSet('CFOP', ['retorno' => "Sucesso"]));
       
     } catch (\Exception $e){
       $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
     }
   }
  
}