<?php
/**
 * Created by PhpStorm.
 * User: erikasantos
 * Date: 09/04/14
 * Time: 19:46
 */

namespace Geral\Facade;


class OperadorWizard {

    public static function salvaOperador() {

        self::setContextVars();

        list($nrorg, $nmacesso, $dsemailoper, $cdsenhaoperweb, $nrorgtrab,
            $nrestruttrab) = self::getDadosOperador();

        self::validaDadosOperador($nmacesso, $dsemailoper, $cdsenhaoperweb, $nrorgtrab, $nrestruttrab);

        \Geral\Logic\Cadastros\Operador::novo(
            $nrorg, $nmacesso, $dsemailoper, $cdsenhaoperweb, $nrestruttrab
        );
        tk_warning("Cadatro de operador concluído!");

    }


    public static function setContextVars(){
        tk_set_context_vars('NMACESSO', 'operador_wzd_gpe_wnd_operador_wzd', tk_get_field_value('NMACESSO'));
        tk_set_context_vars('DSEMAILOPER', 'operador_wzd_gpe_wnd_operador_wzd', tk_get_field_value('DSEMAILOPER'));
        tk_set_context_vars('CDSENHAOPERWEB', 'operador_wzd_gpe_wnd_operador_wzd', tk_get_field_value('CDSENHAOPERWEB'));
        tk_set_context_vars('PERFILACESSO', 'operador_wzd_gpe_wnd_operador_wzd', tk_get_field_value('PERFILACESSO'));
        tk_set_context_vars('NRORGTRAB', 'operador_wzd_gpe_wnd_operador_wzd', tk_get_context_vars('NRORG','organizacao_wzd_gpe_wnd_org_wzd'));
        tk_set_context_vars('NRESTRUTTRAB', 'operador_wzd_gpe_wnd_operador_wzd', tk_get_context_vars('NRESTRUTURAM', 'organizacao_wzd_gpe_wnd_org_wzd'));
    }

    private static function getDadosOperador(){
        $nmacesso = tk_get_context_vars('NMACESSO', 'operador_wzd_gpe_wnd_operador_wzd');
        $dsemailoper  = tk_get_context_vars('DSEMAILOPER', 'operador_wzd_gpe_wnd_operador_wzd');
        $cdsenhaoperweb = tk_get_context_vars('CDSENHAOPERWEB', 'operador_wzd_gpe_wnd_operador_wzd');
//        $perfilacesso = tk_get_context_vars('PERFILACESSO', 'operador_wzd_gpe_wnd_operador_wzd');
        $nrorgtrab = tk_get_context_vars('NRORG','organizacao_wzd_gpe_wnd_org_wzd');
        $nrestruttrab = tk_get_context_vars('NRESTRUTURAM', 'organizacao_wzd_gpe_wnd_org_wzd');
        $nrorg = $nrorgtrab;

        return array($nrorg, $nmacesso, $dsemailoper, $cdsenhaoperweb, $nrorgtrab, $nrestruttrab);
    }

    private static function validaDadosOperador($nmacesso, $dsemailoper, $cdsenhaoperweb, $nrorgtrab,
                                                $nrestruttrab)
    {
        $operadorPreenchido = $nmacesso != null && $dsemailoper != null && $cdsenhaoperweb != null &&
            $nrorgtrab != null && $nrestruttrab != null;



        if (!$operadorPreenchido) {

            throw new \Exception('Todos os campos devem ser preenchidos');
        }
    }
}