<?php

require_once 'base/AproativtareEntityBase.php';


/**
 * Coloque a descrio aqui.
 *
 * @package Entity
 * @author  walterrodrigues
 */
class AproativtareEntity extends AproativtareEntityBase
{


    /**
     * Altera data final da atividade.
     *
     * @param string  $dtfirativtar Data final da Atividade.
     * @param integer $cdfilial     Codigo da filial.
     * @param integer $nrtarefa     Numero da tarefa.
     * @param integer $nrplativtare Numero do plano da atividade.
     *
     * @return boolean
     */
    static public function alteraDataFinalAtividade(
        $dtfirativtar,
        $cdfilial,
        $nrtarefa,
        $nrplativtare
        ){

            $obj = Aproativtare::alteraDataFinalAtividade(
                $dtfirativtar,
                $cdfilial,
                $nrtarefa,
                $nrplativtare
            );
            return $obj;
        }


    /**
     * Insere na tabela Aproativdade.
     *
     * @param string $cdfilial     Codigo da filial.
     * @param string $nrtarefa     Numero da tarefa.
     * @param string $nrplativtare Numero do plano da atividade.
     * @param string $cdoperador   Codigo do operador.
     * @param string $now          Data atual.
     *
     * @return void
     */
    public static function insereAproativdade(
        $cdfilial,
        $nrtarefa,
        $nrplativtare,
        $cdoperador,
        $now
        ){

        $obj = new self();
        $obj->setCdfilial($cdfilial);
        $obj->setNrtarefa($nrtarefa);
        $obj->setNrplativtare($nrplativtare);
        $obj->setDtiapativtar($now);
        $obj->setDthiapativta($now);
        $obj->setDtinclusao($now);
        $obj->setCdoperador($cdoperador);
        $obj->persist();
    }


}

